Randomized Algorithms for Low-Rank Matrix Factorizations: Sharp Performance Bounds
Abstract
The development of randomized algorithms for numerical linear algebra, e.g. for computing approximate QR and SVD factorizations, has recently become an intense area of research. This paper studies one of the most frequently discussed algorithms in the literature for dimensionality reduction—specifically for approximating an input matrix with a low-rank element. We introduce a novel and rather intuitive analysis of the algorithm in [6], which allows us to derive sharp estimates and give new insights about its performance. This analysis yields theoretical guarantees about the approximation error and at the same time, ultimate limits of performance (lower bounds) showing that our upper bounds are tight. Numerical experiments complement our study and show the tightness of our predictions compared with empirical observations.
1 Introduction
Almost any method one can think of in data analysis and scientific computing relies on matrix algorithms. In the era of ‘big data’, we must now routinely deal with matrices of enormous sizes and reliable algorithmic solutions for computing solutions to least-squares problems, for computing approximate QR and SVD factorizations and other such fundamental decompositions are urgently needed. Fortunately, the development of randomized algorithms for numerical linear algebra has seen a new surge in recent years and we begin to see computational tools of a probabilistic nature with the potential to address some of the great challenges posed by big data. In this paper, we study one of the most frequently discussed algorithms in the literature for dimensionality reduction, and provide a novel analysis which gives sharp performance bounds.
1.1 Approximate low-rank matrix factorization
We are concerned with the fundamental problem of approximately factorizing an arbitrary matrix as
(1.1) |
where is the desired rank. The goal is to compute and such that is as small as possible. Typically, one measures the quality of the approximation by taking either the spectral norm (the largest singular value, also known as the 2 norm) or the Frobenius norm (the root-sum of squares of the singular values) of the residual . It is well-known that the best rank- approximation, measured either in the spectral or Frobenius norm, is obtained by truncating the singular value decomposition (SVD), but this can be prohibitively expensive when dealing with large matrix dimensions.
Recent work [6] introduced a randomized algorithm for matrix factorization with lower computational complexity.
The algorithm is simple to understand: is an approximation of the range of ; we therefore project the columns of onto this approximate range by means of the orthogonal projector and hope that . Of natural interest is the accuracy of this procedure: how large is the size of the residual? Specifically, how large is ?
The subject of the beautiful survey [3] as well as [6] is to study this problem and provide an analysis of performance. Before we state the sharpest results known to date, we first recall that if are the ordered singular values of , then the best rank- approximation obeys
It is known that there are choices of such that is greater than by an arbitrary multiplicative factor, see e.g. [3]. For example, setting
and , direct computation shows that . Thus, we write (where ) and seek and such that
We are now ready to state the best results concerning the performance of Algorithm 1 we are aware of.
It is a priori unclear whether this upper bound correctly predicts the expected behavior or not. That is to say, is the dependence upon the problem parameters in the right-hand side of the right order of magnitude? Is the bound tight or can it be substantially improved? Are there lower bounds which would provide ultimate limits of performance? The aim of this paper is merely to provide some definite answers to such questions.
1.2 Sharp bounds
It is convenient to write the residual in Algorithm 1 as as to make the dependence on the random test matrix explicit. Our main result states that there is an explicit random variable whose size completely determines the accuracy of the algorithm. This statement uses a natural notion of stochastic ordering; below we write if and only if the random variables and obey for all .
Theorem 1.2.
Suppose without loss of generality that . Then in the setup of Theorem 1.1, for each matrix ,
where is the random variable
(1.3) |
here, and are respectively and matrices with i.i.d. entries, is a diagonal matrix with the singular values of a Gaussian matrix with i.i.d. entries, and is the -dimensional identity matrix. Furthermore, , and are all independent (and independent from ). In the other direction, for any , there is a matrix with the property
In particular, this gives
The proof of the theorem is in Section 2.3. To obtain very concrete bounds from this theorem, one can imagine using Monte Carlo simulations by sampling from to estimate the worst error the algorithm commits. Alternatively, one could derive upper and lower bounds about by analytic means. The corollary below is established in Section 2.4.
Corollary 1.3 (Nonasymptotic bounds).
With as in (1.3) (recall ),
(1.4) |
In the regime of interest where is very large and , the ratio between the upper and lower bound is practically equal to 1 so our analysis is very tight. Furthermore, Corollary 1.3 clearly emphasizes why we would want to take . Indeed, when , is square and nearly singular so that both and the lower bound become very large. In contrast, increasing yields a sharp decrease in and, thus, improved performance.
It is further possible to derive explicit bounds by noting (Lemma A.2) that
(1.5) |
Plugging the right inequality into (1.4) improves upon (1.2) from [3]. In the regime where (we assume throughout this section that ), taking , for instance, yields an upper bound roughly equal to and a lower bound roughly equal to , see Figure 1.
When and are reasonably large, it is well-known (see Lemma A.3) that
so that in the regime of interest where , both the lower and upper bounds in (1.4) are about equal to
(1.6) |
We can formalize this as follows: in the limit of large dimensions where , with (in such a way that ), we have almost surely
(1.7) |
Conversely, it holds almost surely that
(1.8) |
A short justification of this limit behavior may also be found in Section 2.4.
1.3 Innovations
Whereas the analysis in [3] uses sophisticated concepts and tools from matrix analysis and from perturbation analysis, our method is different and only uses elementary ideas (for instance, it should be understandable by an undergraduate student with no special training). In a nutshell, the authors in [3] control the error of Algorithm 1 by establishing an upper bound about holding for all matrices (the bound depends on ). From this, they deduce bounds about in expectation and in probability by integrating with respect to . A limitation of this approach is that it does not provide any estimate of how close the upper bound is to being tight.
In contrast, we perform a sequence of reductions, which ultimately identifies the worst-case input matrix. The crux of this reduction is a monotonicity property, which roughly says that if the spectrum of a matrix is larger than that of another matrix , then the singular values of the residual are stochastically greater than those of , see Lemma 2.1 in Section 2.1 for details. Hence, applying the algorithm to results in a larger error than when the algorithm is applied to . In turn, this monotonicity property allows us to write the worst-case residual in a very concrete form. With this representation, we can recover the deterministic bound from [3] and immediately see the extent to which it is sub-optimal. Most importantly, our analysis admits matching lower and upper bounds as discussed earlier.
Our analysis of Algorithm 1, presented in Section 2.3, shows that the approximation error is heavily affected by the spectrum of the matrix past its first singular values.111To accommodate this, previous works also provide bounds in terms of the singular values of past . In fact, suppose and let be the diagonal matrix of dimension equal to . Then our method show that the worst case error for matrices with this tail spectrum is equal to the random variable
In turn, a very short argument gives the expected upper bound below:
Theorem 1.4.
This bound is tight in the sense that setting essentially yields the upper bound from Corollary 1.3, which as we have seen, cannot be improved.
1.4 Experimental results
To examine the tightness of our analysis of performance, we apply Algorithm 1 to the ‘worst-case’ input matrix and compute the spectral norm of the residual, performing such computations for fixed values of , , and . We wish to compare the sampled errors with our deterministic upper and lower bounds, as well as with the previous upper bound from Theorem 1.1 and our error proxy (1.6). Because of Lemma 2.2, the worst-case behavior of the algorithm does not depend on and separately but only on . Hence, we set in this section.
Figure 1 reveals that the new upper and lower bounds are tight up to a small multiplicative factor, and that the previous upper bound is also fairly tight. Further, the plots also demonstrate the effect of concentration in measure—the outcomes of different samples each lie remarkably close to the yellow rule of thumb, especially for larger , suggesting that for practical purposes the algorithm is deterministic. Hence, these experimental results reinforce the practical accuracy of the error proxy (1.6) in the regime since we can see that the worst-case error is just about (1.6).
Figure 2 gives us a sense of the variability of the algorithm for two fixed values of the triple . As expected, as and grow the variability of the algorithm decreases, demonstrating the effect of concentration of measure.
1.5 Complements
In order to make the paper a little more self-contained, we briefly review some of the literature as to explain the centrality of the range finding problem (Algorithm 1). For instance, suppose we wish to construct an approximate SVD of a very large matrix matrix . Then this can be achieved by running Algorithm 1 and then computing the SVD of the ‘small’ matrix , check Algorithm 2 below, which returns an approximate SVD . Assuming the extra steps in Algorithm 2 are exact, we have
(1.10) |
so that the approximation error is that of Algorithm 1 whose study is the subject of this paper.
The point here of course is that since the matrix is —we typically have —the computational cost of forming its SVD is on the order of flops and fairly minimal. (For reference, we note that there is an even more effective single-pass variant of Algorithm 2 in which we do not need to re-access the input matrix once is available, please see [3] and references therein for details.)
Naturally, we may wish to compute other types of approximate matrix factorizations of such as eigenvalue decompositions, QR factorizations, interpolative decompositions (where one searches for an approximation in which is a subset of the columns of ), and so on. All such computations would follow the same pattern: (1) apply Algorithm 1 to find an approximate range, and (2) perform classical matrix factorizations on a matrix of reduced size. This general strategy, namely, approximation followed by standard matrix computations, is of course hardly anything new. To be sure, the classical Businger-Golub algorithms for computing partial QR decompositions follows this pattern. Again, we refer the interested reader to the survey [3].
We have seen that when the input matrix does not have a rapidly decaying spectrum, as this may be the case in a number of data analysis applications, the error of approximation Algorithm 1 commits—the random variable in Theorem 1.2—may be quite large. In fact, when the singular values hardly decay at all, it typically is on the order of the error proxy (1.6). This results in poor performance. On the other hand, when the singular values decay rapidly, we have seen that the algorithm is provably accurate, compare Theorem 1.4. This suggests using a power iteration, similar to the block power method, or the subspace iteration in numerical linear algebra: Algorithm 3 was proposed in [7].
The idea in Algorithm 3 is of course to turn a slowly decaying spectrum into a rapidly decaying one at the cost of more computations: we need matrix-matrix multiplies instead of just one. The benefit is improved accuracy. Letting be any orthogonal projector, then a sort of Jensen inequality states that for any matrix ,
see [3] for a proof. Therefore, if is computed via the power trick (Algorithm 3), then
This immediately gives a corollary to Theorem 1.2.
It is amusing to note that with, say, , , and the error proxy (1.6) for , the size of the error factor in (1.11) is about 3.41 when .
Further, we would like to note that our analysis exhibits a sequence of matrices (2.1) that have approximation errors that limit to the worst case approximation error when . However, when , this same sequence of matrices limits to having an approximation error exactly equal to , which is the best possible since this is the error achieved by truncating the SVD. It would be interesting to study the tightness of the upper bound (1.11) and we leave this to future research.
1.6 Notation
In Section 3, we shall see that among all possible test matrices, Gaussian inputs are in some sense optimal. Otherwise, the rest of the paper is mainly devoted to proving the novel results we have just presented. Before we do this, however, we pause to introduce some notation that shall be used throughout. We reserve to denote the identity matrix. When is an random Gaussian matrix, we write to save space. Hence, is a random variable.
We use the partial ordering of -dimensional vectors and write if has nonnegative entries. Similarly, we use the semidefinite (partial) ordering and write if is positive semidefinite. We also introduce a notion of stochastic ordering in : given two -dimensional random vectors and , we say that if for all . If instead then we say that and are equal in distribution and write . A function is monotone non-decreasing if implies . Note that if is monotone non-decreasing and , then .
2 Proofs
2.1 Monotonicity
The key insight underlying our analysis is this:
Lemma 2.1 (Monotonicity).
If and are matrices of the same dimensions obeying , then
The implications of this lemma are two-fold. First, to derive error estimates, we can work with diagonal matrices without any loss of generality. Second and more importantly, it follows from the monotonicity property that
(2.1) |
The rest of this section is thus organized as follows:
-
•
The proof of the monotonicity lemma is in Section 2.2.
- •
- •
- •
Additional supporting materials are found in the Appendix.
2.2 Proof of the monotonicity property
We begin with an intuitive lemma.
Lemma 2.2 (Rotational invariance).
Let , , be arbitrary matrices with and orthogonal. Then . In particular, if is a singular value decomposition of , then .
Proof.
Observe that by spherical symmetry of the Gaussian distribution, a test vector (a column of ) has the same distribution as . We have
and thus,
Hence, , which means that the distribution of depends only upon . By induction, one establishes in the same fashion. The induction step uses Lemma A.4, which states that , where and are a partition of the columns of . ∎
A consequence of this lemma is that we only need to show the monotonicity property for pairs of diagonal matrices obeying . The lemma below proves the monotonicity property in the special case where .
Lemma 2.3.
Let and be diagonal and positive semidefinite matrices obeying . Let be an arbitrary vector in . Then for all ,
This implies that .
Proof.
Introduce
in which is the diagonal matrix with on the diagonal. Clearly, it suffices to show that to prove the first claim. Putting , is given by
Taking derivatives gives
Hence, .
Lemma 2.4.
If for all , then .
We now extend the proof to arbitrary , which finishes the proof of the monotonicity property.
Lemma 2.5.
Proof.
Fix and put . The vector uniquely decomposes as the sum of and , where belongs to the range of and is the orthogonal component. Now, since is in the range of , there exists such that . We have
Therefore, Lemma 2.3 gives
The last inequality follows from being in the range of . In details, let (resp. ) be the orthogonal projector onto the range of (resp. ). Then Pythagoras’ theorem gives
The second part of the lemma is once more a consequence of Lemma 2.4. ∎
2.3 Proof of Theorem 1.2
We let be an -dimensional diagonal matrix and work with
(2.2) |
Set and partition the rows as
Next, introduce an SVD for
and partition as
A simple calculation shows that
Hence, and have the same column space. If is an orthonormal basis for the range of , we conclude that
have the same column space as . Note that the last columns of are orthonormal.
Continuing, we let be the first columns of . Then Lemma 2.6 below allows us to decompose as
where is orthogonal with the same range space as and has a spectral norm at most . Further since the first columns of are orthogonal to the last columns, we have
where is orthogonal with the same range space as and has a spectral norm also at most . This gives
We have reached the conclusion
(2.3) |
When , this gives our theorem.
Lemma 2.6.
Let . Then is in Frobenius norm away from a matrix with the same range and orthonormal columns.
Proof.
We need to construct a matrix obeying and such that (1) is orthogonal and (2) and have the same range. Let be a reduced SVD decomposition for ,
Clearly, is an orthonormal matrix with the same range as . Next, the th singular value of obeys
Hence,
which proves the claim. ∎
2.4 Proof of Corollary 1.3
Put . Since is an orthogonal projector, and (2.3) gives
(2.4) |
Also,
(2.5) |
Standard estimates in random matrix theory (Lemma A.1) give
Hence,
Conversely, letting be the index corresponding to the largest entry of , we have . Therefore,
where is the th column of . Now is the projection of a Gaussian vector onto a plane of dimension drawn independently and uniformly at random. This says that , where is a chi-square random variable with degrees of freedom. If is a nonnegative random variable, then222This follows from Hölder’s inequality with , .
(2.6) |
Since and , we have
2.5 Proof of Theorem 1.4
Take as in (2.2) with on the diagonal of . Applying (2.3) gives
(2.7) |
We follow [3, Proof of Theorem 10.6] and use an inequality of Gordon to establish
where is expectation over . Further, it is well-known that
The reason is that , where is a Wishart matrix . The identity follows from [5, Exercise 3.4.13]. In summary, the expectation of the right-hand side in (2.7) is bounded above by
Since , the conclusion of the theorem follows.
3 Discussion
We have developed a new method for characterizing the performance of a well-studied algorithm in randomized numerical linear algebra and used it to prove sharp performance bounds. A natural question to ask when using Algorithm 1 is if one should draw from some distribution other than the Gaussian. It turns out that for all values and , choosing with Gaussian entries minimizes
This is formalized as follows:
Lemma 3.1.
Choosing with i.i.d. Gaussian entries minimizes the supremum of across all choices of .
Proof.
Fix with (this is no loss of generality) and suppose is sampled from an arbitrary measure with probability of being rank (since being lower rank can only increase the error). The expected error is , where for arbitrary matrices, in which is the orthogonal projection onto the range of . Suppose further that is drawn uniformly at random from the space of orthonormal matrices. Then if is sampled from the Gaussian distribution,
since chooses a subspace uniformly at random as does . Therefore, there exists with the property , whence
Hence, the expected error using a test matrix drawn from the Gaussian distribution on is smaller or equal to that when using a test matrix drawn from another distribution on . Since the singular values of and are identical since is orthogonal, the Gaussian measure (or any measure that results in a rotationally invariant choice of rank subspaces) is worst-case optimal for the spectral norm. ∎
The analysis presented in this paper does not generalize to a test matrix drawn from the subsampled random Fourier transform (SRFT) distribution as suggested in [10]. Despite their inferior performance in the sense of Lemma 3.1, SRFT test matrices are computationally attractive since they come with fast algorithms for matrix-matrix multiply.
Appendix A Appendix
We use well-known bounds to control the expectation of the extremal singular values of a Gaussian matrix. These bounds are recalled in [8], though known earlier.
Lemma A.1.
If and is a matrix with i.i.d. entries, then
Next, we control the expectation of the norm of the pseudo-inverse of a Gaussian matrix .
Lemma A.2.
In the setup of Lemma A.1, we have
Proof.
The upper bound is the same as is used in [3] and follows from the work of [1]. For the lower bound, set which has an inverse Wishart distribution, and observe that
where is the entry in the position. It is known that , where is distributed as a chi-square variable with degrees of freedom [5, Page 72]. Hence,
∎
Lemma A.3.
Let be a sequence of matrix with i.i.d. entries such that . Then
Finally, the lemma below is used in the proof of Lemma 2.2.
Lemma A.4.
Put for convenience. Take and , with each . Then
This implies that and ( times) .
Proof.
We assume and use induction for larger . is the projection of onto the subspace orthogonal to and is the projection of onto the subspace orthogonal to . However, and are orthogonal subspaces and, therefore, is the projection of onto the subspace orthogonal to ; this is . ∎
Acknowledgements
E. C. is partially supported by NSF via grant CCF-0963835 and by a gift from the Broadcom Foundation. We thank Carlos Sing-Long for useful feedback about an earlier version of the manuscript. These results were presented in July 2013 at the European Meeting of Statisticians.
References
- [1] Z. Chen and J. J. Dongarra, “Condition numbers of Gaussian random matrices”. SIAM J. Matrix Anal. Appl., Vol. 27, pp. 603–620, 2005.
- [2] S. Geman, “A limit theorem for the norm of random matrices”. Ann. Prob., Vol. 8, pp. 252–261, 1980.
- [3] N. Halko, P-G. Martinsson, and J. A. Tropp, “Finding structure with randomness: probabilistic algorithms for constructing approximate matrix decompositions”. SIAM Review, Vol. 53, pp. 217–288, 2011.
- [4] R. A. Horn, and C. R. Johnson, Matrix Analysis. Cambridge University Press, 1985.
- [5] K. V. Mardia, J. T. Kent, and J. M. Bibby. Multivariate Analysis. Academic Press, London, 1979.
- [6] P-G. Martinsson, V. Rokhlin, and M. Tygert, “A Fast Randomized Algorithm for the Approximation of Matrices”. Appl. Comp. Harm. Anal., Vol. 30, pp. 47–68, 2011. (Early version published as YALEU/DCS/TR-1361, 2006.)
- [7] V. Rokhlin, A. Szlam, and M. Tygert, “A randomized algorithm for principal component analysis”. SIAM J. Matrix Anal. Appl., Vol. 31, pp. 1100–1124, 2009.
- [8] M. Rudelson, and R. Vershynin, “Non-asymptotic theory of random matrices: extreme singular values”. In Proceedings of the International Congress of Mathematicians, Vol. III, pp. 1576–1602, Hindustan Book Agency, New Delhi, 2010.
- [9] J. W. Silverstein, “The smallest eigenvalue of a large dimensional Wishart matrix”. Ann. Prob., Vol. 13, pp. 1364-1368, 1985.
- [10] F. Woolfe, E. Liberty, V. Rokhlin, and M. Tygert “A fast randomized algorithm for the approximation of matrices” Appl. Comp. Harmon. Anal., Vol. 25, pp. 335–366, 2008.